// ME4SE - A MicroEdition Emulation for J2SE 
//
// Copyright (C) 2001 Stefan Haustein, Oberhausen (Rhld.), Germany
//
// Contributors:
//
// STATUS: API complete
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version. This program is
// distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
// License for more details. You should have received a copy of the
// GNU General Public License along with this program; if not, write
// to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.

// should we remove the dependency on the application manager?

package javax.microedition.lcdui;

import javax.microedition.midlet.*;
import java.util.*;
import java.awt.event.*;
import org.me4se.*;
import org.kobjects.scm.*;

public class Display {

	static Hashtable midlets = new Hashtable();

	MIDlet midlet;
	Displayable current;
	static DisplayableContainer currentContainer;
	Vector callSerially = new Vector();

	Display(MIDlet midlet) {
		this.midlet = midlet;
	}

	public void callSerially(Runnable r) {
		callSerially.addElement(r);
		if (current != null)
			current.container.repaint();
	}

	public static Display getDisplay(MIDlet midlet) {

		Display display = (Display) midlets.get(midlet);
		if (display == null) {
			display = new Display(midlet);
			midlets.put(midlet, display);
		}

		return display;
	}

	public synchronized void setCurrent(Displayable d) {

		ApplicationManager manager = ApplicationManager.manager;

		if (current == d)
			return;

		if (ApplicationManager.manager.active != midlet)
			return;

		if (currentContainer != null)
			manager.displayContainer.remove(currentContainer);

		if (current instanceof Canvas)
			 ((Canvas) current).hideNotify();

		if (d == null) {
			current = null;
			currentContainer = null;
		}
		else {
			d.container.setX(manager.getIntProperty("screen.x", 0));
			d.container.setY(manager.getIntProperty("screen.y", 0));

			if (d instanceof Alert) {
				Alert alert = (Alert) d;
				if (alert.next == null)
					alert.next = current;
			}

			manager.displayContainer.add(d.container);
			d.display = this;
			current = d;
			currentContainer = d.container;
			current._showNotify();
			//System.out.println("Display.Current: " + current);
			manager.wrapper.requestFocus();
			currentContainer.repaint();
		}
	}

	public void setCurrent(Alert alert, Displayable next) {
		alert.next = next;
		setCurrent(alert);
	}

	public boolean isColor() {
		return true;
	}

	public int numColors() {
		return 1 << (java.awt.Toolkit.getDefaultToolkit().getColorModel().getPixelSize() - 1);
	}

	public Displayable getCurrent() {
		return current;
	}

	static void check() {
		if (ApplicationManager.manager.frame != null && !ApplicationManager.manager.frame.isVisible()) {
			java.awt.Frame frame = ApplicationManager.manager.frame;
			frame.pack();
			frame.show();
			frame.setResizable(false);
		}
	}

}
