// ME4SE - A MicroEdition Emulation for J2SE 
//
// Copyright (C) 2001 Stefan Haustein, Oberhausen (Rhld.), Germany
//
// Contributors: API Complete
//
// STATUS:
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version. This program is
// distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
// License for more details. You should have received a copy of the
// GNU General Public License along with this program; if not, write
// to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.

package javax.microedition.lcdui;

import java.util.Vector;
import org.me4se.impl.lcdui.*;

public class TextBox extends Screen {

    TextComponent box = new TextComponent("textBox");
    int maxSize;


    public TextBox(String title, String text, int maxSize, int constraints) {
        super(title);
        box.setText(text);
	box.setConstraints (constraints);
        container.setMain (box);

        // use fixed limitof 64K or so???
        int actualSize = (int) Runtime.getRuntime().freeMemory() / 4;
        if (maxSize > actualSize)
            maxSize = actualSize;

        this.maxSize = maxSize;
    }

    public void setString(String text) {
        box.setText(text);
    }

    public int getMaxSize() {
        return maxSize;
    }

    public int setMaxSize(int maxSize) {
        this.maxSize = maxSize;
        return maxSize;
    }

    public String getString() {
        return box.getText();
    }

    public void delete(int offset, int length) {
        String s = getString();
        setString(s.substring(0, offset) + s.substring(offset + length));
    }

    public int getCaretPosition() {
        return 0;
    }

    public int getChars(char[] data) {
        String s = getString();
        int l = s.length();
        s.getChars(0, l, data, 0);
        return l;
    }

    public int getConstraints() {
        return box.getConstraints();
    }

    public void insert(char[] data, int offset, int length, int position) {
        insert(new String(data, offset, length), position);
    }

    public void insert(String src, int position) {
        String s = getString();
        setString(s.substring(0, position) + src + s.substring(position));
    }

    public void setChars(char[] data, int offset, int length) {
        setString(new String(data, offset, length));
    }

    public void setConstraints(int constraints) {
        box.setConstraints (constraints);
    }

    public int size() {
        return getString().length();
    }


   void _showNotify () {
       box.requestFocus ();
   }
}
