// ME4SE - A MicroEdition Emulation for J2SE
//
// Copyright (C) 2001 Stefan Haustein, Oberhausen (Rhld.), Germany
//
// Contributors: Sebastian Vastag
//
// STATUS: API complete
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version. This program is
// distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
// License for more details. You should have received a copy of the
// GNU General Public License along with this program; if not, write
// to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
// Boston, MA 02111-1307, USA.

package javax.microedition.midlet;

import javax.microedition.lcdui.*;
import org.me4se.*;
import org.me4se.impl.*;
import org.me4se.impl.jam.*;

public abstract class MIDlet {

	public MIDlet() {

		if (ApplicationManager.manager == null)
			new ApplicationManager(null, new java.util.Properties());

		ApplicationManager.manager.active = this;
		/*
			Display d = Display.getDisplay (this);
			Canvas c = new Canvas () {
				public void paint (Graphics g) {
		
				}
			    };
		
			d.setCurrent (c);
			c.getWidth ();
			c.getHeight ();
			//	d.setCurrent (null); */
	}

	protected abstract void destroyApp(boolean unconditional) throws MIDletStateChangeException;

	// what about the manifest...?

	public String getAppProperty(String key) {

		return ApplicationManager.manager.jadFile.getValue(key);

		/*
		if (key.equals ("microedition.configuration"))
		    return "CLDC 1.0";
		if (key.equals ("microedition.profiles"))
		    return "MIDP 1.0";
		
		if (key.equals ("microedition.encoding"))
		    return "UTF-8";
		*/

	}

	public void notifyDestroyed() {
		/**
		 * If the MIDlet currently being destroyed is one of several MIDlets
		 * in a MIDlet suite, start the MIDletChooser again to give the user
		 * a chance to run another MIDlet of the suite.
		 */

		ApplicationManager manager = ApplicationManager.manager;
		String jam = manager.properties.getProperty("jam");

        int midletCount = manager.jadFile.getMIDletCount();
        
		if (midletCount > 1 || manager.isApplet || jam != null) {

            try {
    			String active = manager.active.getClass().getName();
    			if (active.equals("org.me4se.impl.MIDletChooser") || midletCount == 1) {
    				if (jam != null)
    					manager.startMIDlet(jam);
    			}
    			else if (active.equals(jam)) {
    				System.exit(0);
    			}
    			else {
    				manager.startMIDlet("org.me4se.impl.MIDletChooser");
    			}
            }
            catch (Exception e) {
                e.printStackTrace();
                System.exit(0);
            }
		}
		else
			System.exit(0);
	}

	public void notifyPaused() {
	}

	protected abstract void pauseApp();

	public void resumeRequest() {
		/*try {
		    startApp ();
		}
		catch (MIDletStateChangeException e) {
		} */
	}

	protected abstract void startApp() throws MIDletStateChangeException;

}