package org.me4se.impl.lcdui;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import javax.microedition.midlet.ApplicationManager;

import org.kobjects.scm.*;

/**
 * @author Stefan Haustein
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 */
public class DeviceComponent extends ScmComponent {

    protected FontInfo[] fontInfo;
    public boolean selectButtonRequired;

    public DeviceComponent(String type, boolean focusable) {

	fontInfo = new FontInfo[] { FontInfo.getFontInfo(type), FontInfo.getFontInfo(type + ".focus")};

	//        updateStyle();

	setFocusable(focusable);
    }

    public void paint(Graphics g) {
	super.paint(g);
		
	int w = getWidth();
	int h = getHeight();
	
	FontInfo fi = getFontInfo();
	g.setColor(fi.foreground);
	
	if ((fi.decoration & FontInfo.SHADOW) != 0) {
	    g.drawRoundRect(0, 0, w - 2, h - 2, 3, 3);
	    g.drawLine(2, h - 1, w - 4, h - 1);
	    g.drawLine(w - 1, 2, w - 1, h - 4);
	}
	else if ((fi.decoration & FontInfo.LIGHT) != 0) {
	    g.setColor(new java.awt.Color(ApplicationManager.manager.getDeviceColor(0x0808080, false)));
	    g.drawRoundRect(0, 0, w - 1, h - 1, 3, 3);
	    //g.setColor(foreground);
	}
	else if ((fi.decoration & FontInfo.UNDERLINE) != 0)
	    g.drawLine(0, h - 1, w - 1, h - 1);
    }


    public boolean keyPressed(int code, int mask) {
		//System.out.println("keypressed!");

		int dir = 0;
		if (code == KeyEvent.VK_UP)
			dir = -1;
		else if (code == KeyEvent.VK_DOWN)
			dir = 1;

		if (dir == 0)
			return false;

		ScmContainer parent = getParent();
		int count = parent.getComponentCount();
		int i0 = parent.indexOf(this);
		int i = i0;
		do {
			i += dir;
			if (i < 0)
				i = count - 1;
			else if (i >= count)
				i = 0;

			ScmComponent c = parent.getComponent(i);
			if (parent.getY() + c.getY() < 0 || parent.getY() + c.getY() + c.getHeight() > parent.getParent().getHeight() || c.getFocusable())
				break;
		}
		while (i != i0);

		parent.getComponent(i).requestFocus();
		return true;
	}

    public void focusGained () {
	 getParent ().focusGained ();
    }


	public void setBounds(int x, int y, int w, int h) {
		super.setBounds(x, y, w, h);
	}

	protected FontInfo getFontInfo() {
		return fontInfo[(hasFocus() && getFocusable()) ? 1 : 0];
	}

	public Dimension getMinimumSize() {
		return new Dimension(0, getFontInfo().height);
	}
}

